package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class InsertionSortBinarySearch implements ISort
{
	
	public InsertionSortBinarySearch ()
	{}

	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);
	}

	public void sort (int[] arr, int begin, int end)
	{
		int key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i--;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (int[] arr, int key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		int comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);
	}
	
	public void sort (String[] arr, int begin, int end)
	{
		String key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (String[] arr, String key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		int comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = key.compareToIgnoreCase(arr[mid]);
			
			if (comp < 0)
			{
				high = mid - 1;	
			}		
			else if (comp > 0)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (long[] arr, int begin, int end)
	{
		long key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (long[] arr, long key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		long comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}

	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (short[] arr, int begin, int end)
	{
		short key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (short[] arr, short key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		short comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (double[] arr, int begin, int end)
	{
		double key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (double[] arr, double key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		double comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (float[] arr, int begin, int end)
	{
		float key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (float[] arr, float key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		float comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}

	public void sort (char[] arr, int begin, int end)
	{
		char key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (char[] arr, char key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		char comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
		byte key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;	
			}
			arr[i+1] = key;
		}	
	}
	
	public int binarySearch (byte[] arr, byte key, int low, int high) 
	{	
		high = high - 1;
		int mid;
		byte comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = arr[mid];
			
			if (key < comp)
			{
				high = mid - 1;	
			}		
			else if (key > comp)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName)  
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, 
							Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		try
		{
			Object key;
			int insertionPosition;
			int i;
			for (int index = begin+1; index <= end; index++)
			{
				key = arr[index];
				insertionPosition = binarySearch(arr, key, begin, index, c, methodName, paramTypes, paramValues);
				i = index - 1;
				while (i >= begin && i >= insertionPosition)
				{
					arr[i+1] = arr[i];
					i = i - 1;	
				}
				arr[i+1] = key;
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public int binarySearch (Object[] arr, Object key, int low, int high, Comparator c, String methodName,
							Class[] paramTypes, Object[] paramValues) throws Exception 
	{	
		high = high - 1;
		int mid;
		int comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = c.compare(ReflectionUtil.getMethodValue (key, methodName, paramTypes, paramValues),
							ReflectionUtil.getMethodValue (arr[mid], methodName, paramTypes, paramValues));
							
			if ( comp  < 0 )
			{
				high = mid - 1;	
			}		
			else if ( comp  > 0 )
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		Object key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr[index];
			insertionPosition = binarySearch(arr, key, begin, index, c);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr[i+1] = arr[i];
				i = i - 1;
			}
			arr[i+1] = key;	
		}	
	}
	
	public int binarySearch (Object[] arr, Object key, int low, int high, Comparator c)
	{	
		high = high - 1;
		int mid;
		int comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = c.compare (key, arr[mid]);
			if ( comp < 0 )
			{
				high = mid - 1;	
			}		
			else if ( comp > 0)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}

	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);	
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		Object key;
		int insertionPosition;
		int i;
		for (int index = begin+1; index <= end; index++)
		{
			key = arr.get(index);
			insertionPosition = binarySearch(arr, key, begin, index, c);
			i = index - 1;
			while (i >= begin && i >= insertionPosition)
			{
				arr.set(i+1, arr.get(i));
				i = i - 1;
			}
			arr.set(i+1, key);	
		}	
	}
	
	public int binarySearch (List arr, Object key, int low, int high, Comparator c)
	{	
		high = high - 1;
		int mid;
		int comp;
		while (low <= high)
		{
			mid = (low + high) / 2;
			comp = c.compare (key, arr.get(mid));
			if ( comp < 0 )
			{
				high = mid - 1;	
			}		
			else if ( comp > 0)
			{
				low = mid + 1;	
			}
			else
			{
				return mid;	
			}
		}
		return ((high+1) + low) / 2;
	}
}