package com.rp.util.sort;

import com.rp.util.sort.ISort;
import com.rp.util.sort.SortException;
import com.rp.util.ReflectionUtil;
import java.util.Comparator;
import java.util.List;

public final class ShellSort implements ISort
{
	public ShellSort ()
	{}

	public void sort (int[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort(int arr[], int begin, int end)
	{
 		int increment = 3;
 		int temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (String[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (String[] arr, int begin, int end)
	{
 		int increment = 3;
 		String temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment].compareToIgnoreCase(temp) > 0))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (long[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (long[] arr, int begin, int end)
	{
 		int increment = 3;
 		long temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (short[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (short[] arr, int begin, int end)
	{
 		int increment = 3;
 		short temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (double[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (double[] arr, int begin, int end)
	{
 		int increment = 3;
 		double temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (float[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (float[] arr, int begin, int end)
	{
 		int increment = 3;
 		float temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (char[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (char[] arr, int begin, int end)
	{
 		int increment = 3;
 		char temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (byte[] arr)
	{
		sort (arr, 0, arr.length-1);	
	}
	
	public void sort (byte[] arr, int begin, int end)
	{
 		int increment = 3;
 		byte temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (arr[j-increment] > temp))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (Object[] arr, Comparator c, String methodName) throws SortException
	{
		sort (arr, c, methodName, new Class[0], new Object[0]);	
	}
	
	public void sort (Object[] arr, Comparator c, String methodName, Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		sort (arr, 0, arr.length-1, c, methodName, paramTypes, paramValues);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName)  
							throws SortException
	{
		sort (arr, begin, end, c, methodName, new Class[0], new Object[0]);
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c, String methodName, 
							Class[] paramTypes, Object[] paramValues)  
							throws SortException
	{
		try
		{
			int increment = 3;
	 		Object temp;
	 		int j;
	 		while (increment > 0)
			{
				for (int i = begin; i <= end; i++)
				{
					j = i;
					temp = arr[i];
					while ((j >= increment) && 
					(c.compare(ReflectionUtil.getMethodValue (arr[j-increment], methodName, paramTypes, paramValues),
					ReflectionUtil.getMethodValue (temp, methodName, paramTypes, paramValues)) > 0))
					{
						arr[j] = arr[j - increment];
						j = j - increment;
					}
					arr[j] = temp;
				}
				if (increment/2 != 0)
					increment = increment/2;
				else if (increment == 1)
					increment = 0;
				else
					increment = 1;
			}
		}
		catch (Exception e)
		{
			throw new SortException (e);	
		}
	}
	
	public void sort (Object[] arr, Comparator c)
	{
		sort (arr, 0, arr.length-1, c);	
	}
	
	public void sort (Object[] arr, int begin, int end, Comparator c)
	{
		int increment = 3;
 		Object temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr[i];
				while ((j >= increment) && (c.compare(arr[j-increment],temp) > 0))
				{
					arr[j] = arr[j - increment];
					j = j - increment;
				}
				arr[j] = temp;
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
	
	public void sort (List arr, Comparator c)
	{
		sort (arr, 0, arr.size()-1, c);	
	}
	
	public void sort (List arr, int begin, int end, Comparator c)
	{
		int increment = 3;
 		Object temp;
 		int j;
 		while (increment > 0)
		{
			for (int i = begin; i <= end; i++)
			{
				j = i;
				temp = arr.get(i);
				while ((j >= increment) && (c.compare(arr.get(j-increment),temp) > 0))
				{
					arr.set(j, arr.get(j - increment));
					j = j - increment;
				}
				arr.set(j, temp);
			}
			if (increment/2 != 0)
				increment = increment/2;
			else if (increment == 1)
				increment = 0;
			else
				increment = 1;
		}
	}
}